//
//  BPlugin.h
//  Blocks
//
//  Created by Jesse Grosjean on 8/21/07.
//  Copyright 2007 Blocks. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class BRequirement;
@class BExtensionPoint;
@class BExtension;

@interface BPlugin : NSObject {
    NSBundle *bundle;
	NSString *label;
	NSString *version;
	NSString *identifier;
	NSMutableArray *requirements;
	NSMutableArray *extensionPoints;
	NSMutableArray *extensions;
	int discoveryOrder;
}

#pragma mark Class Methods

+ (BPlugin *)pluginForClass:(Class)aClass;
							 
#pragma mark Init

- (id)initWithBundle:(NSBundle *)aBundle;
	
#pragma mark Attributes

- (NSBundle *)bundle;
- (NSString *)label;
- (NSString *)version;
- (NSString *)identifier;

#pragma mark Relationships

- (NSArray *)requirements;
- (NSArray *)extensionPoints;
- (NSArray *)extensions;
	
#pragma mark Loading Bundle

- (BOOL)isLoaded;
- (BOOL)load;

#pragma mark Util

- (Class)classNamed:(NSString *)className;
- (NSImage *)imageNamed:(NSString *)imageName;
- (NSString *)localizedPluginXmlString:(NSString *)string;

@end